"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConfigurationManager = void 0;
var ConfigurationManager = (function () {
    function ConfigurationManager() {
        this._config = ConfigurationManager.defaultConfiguration;
    }
    Object.defineProperty(ConfigurationManager.prototype, "config", {
        get: function () {
            return this._config;
        },
        enumerable: false,
        configurable: true
    });
    ConfigurationManager.prototype.updateConfig = function (config) {
        if (config) {
            this._config = Object.assign({}, ConfigurationManager.defaultConfiguration, config);
        }
    };
    ConfigurationManager.defaultConfiguration = {
        unitToConvert: 'px',
        viewportWidth: 750,
        unitPrecision: 5,
        propList: ['*'],
        viewportUnit: 'vw',
        fontViewportUnit: 'vw',
        selectorBlackList: [],
        minPixelValue: 1,
        mediaQuery: false,
        replace: true,
        exclude: undefined,
        include: undefined,
        landscape: false,
        landscapeUnit: 'vw',
        landscapeWidth: 568,
        transformRuntime: false,
        tags: ['styled', 'css', 'createGlobalStyle', 'keyframes'],
    };
    return ConfigurationManager;
}());
exports.ConfigurationManager = ConfigurationManager;
exports.default = new ConfigurationManager();
